function ADGroupTool.createSettings()

	local vars = ADGroupTool.vars

	local panelName = "OLDADGroupToolSettingsPanel"
	local panelData = {
		type = "panel",
		name = "|cFF0000Artaeum Group Tool - Outdated|r",
		author = "|c0DC1CF@M0R_Gaming|r",
		slashCommand = "/ad"
	}

	local optionsTable = {

		{
			type = "description",
			title = nil,
			width = "full",
			text = "|cFF0000This addon has been moved to a new esoui entry. It will still work, but I recommend uninstalling this addon and installing the new Artaeum Group Tool on esoui.|r"
		},

		-- STAY ON CROWN MODULE


		{
			type = "header",
			name = "|cFFD700[Stay On Crown Module]|r"
		},
		{
			type = "editbox",
			name = "Time to Kick",
			tooltip = "Time before pugs will be kicked (in minutes).",
			getFunc = function() return vars.offCrownTimerMin end,
			setFunc = function(value) ADGroupTool.setTimer(value) end,
			isMultiline = false
		},
		{
			type = "editbox",
			name = "Radius",
			tooltip = "If pugs are this much away, the timer will start counting for them. A forward camp radius is 25500 units.",
			getFunc = function() return vars.radius end,
			setFunc = function(value) vars.radius = value end,
			isMultiline = false
		},
		{
			type = "editbox",
			name = "Guild ID",
			tooltip = "Enter your whitelist Guild ID in here (-1 for no whitelist)",
			getFunc = function() return vars.guildID end,
			setFunc = function(value) vars.guildID = value end,
			isMultiline = false
		},
		{
			type = "button",
			name = "Toggle Module",
			tooltip = "Click here to toggle [Stay on Crown].",
			func = function() ADGroupTool.startTimer() end
		},
		{
			type = "divider"
		},


		-- DISCORD MODULE


		{
			type = "header",
			name = "|cFFD700[Discord Module]|r"
		},
		{
			type = "editbox",
			name = "Discord Invite Link",
			tooltip = "Please add your discord invite link here.",
			getFunc = function() return ADGroupTool.vars.discordLink end,
			setFunc = function(value) ADGroupTool.vars.discordLink = value end,
			isMultiline = false	--boolean
		},
		{
			type = "editbox",
			name = "Discord Invite Message",
			tooltip = "Please add your discord invite message here.",
			getFunc = function() return ADGroupTool.vars.discordInvite end,
			setFunc = function(value) ADGroupTool.vars.discordInvite = value end,
			isMultiline = true	--boolean
		},
		{
			type = "button",
			name = "Send Discord Invite",
			tooltip = "Click here to send a discord invite!",
			func = function() ADGroupTool.sendDiscord() end
		},
		{
			type = "divider"
		},



	}


	local panel = LibAddonMenu2:RegisterAddonPanel(panelName, panelData)
	LibAddonMenu2:RegisterOptionControls(panelName, optionsTable)

end